Debian Bug report logs - #341152
initrd-tools: unable to boot after replacing devfs with udev: kernel panic, unable to create null, no console

version graph

Package: initrd-tools; Maintainer for initrd-tools is (unknown);

Reported by: Moshe Yudkowsky <speech@pobox.com>

Date: Mon, 28 Nov 2005 19:03:01 UTC

Severity: important

Found in version initrd-tools/0.1.84

Fixed in version 0.1.84.2+rm

Done: Lucas Nussbaum <lucas@lucas-nussbaum.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#341152; Package initrd-tools. Full text and rfc822 format available.

Acknowledgement sent to Moshe Yudkowsky <speech@pobox.com>:
New Bug report received and forwarded. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Moshe Yudkowsky <speech@pobox.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: initrd-tools: unable to boot after replacing devfs with udev: kernel panic, unable to create null, no console
Date: Mon, 28 Nov 2005 12:59:34 -0600
Package: initrd-tools
Version: 0.1.84
Severity: important

I cannot get 2.6.12 or 2.6.12 to boot because of the transition from devfs to udev, and the problem seems to lie with initrd.

The symptom: 

* when I boot using devfs=mount, the boot succeeds. I get a "cannot umount /proc/mount" message but the boot continues.

* when devfs is not running, at about the same point I get a "cannot create null," followed by a "cannot open dev/console," followed by a "Kernel panic" and "Attempting to kill init" message.

Notes: 

When I look at the initrd-img, I notice that there's a "devfs" directory as well as a dev directory. The contents pf the /dev directory are:

lrwxrwxrwx 1 root root   14 Dec 31  1969 cciss -> ../devfs/cciss
crw------- 1 root root 5, 1 Dec 31  1969 console
lrwxrwxrwx 1 root root   12 Dec 31  1969 ida -> ../devfs/ida
drwx------ 1 root root   20 Dec 31  1969 ide
lrwxrwxrwx 1 root root   15 Dec 31  1969 mapper -> ../devfs/mapper
drwx------ 1 root root   32 Dec 31  1969 md
crw-rw-rw- 1 root root 1, 3 Dec 31  1969 null
drwx------ 1 root root   20 Dec 31  1969 scsi

so the console should be available on init, if I understand what's going on (and perhaps I do not).

There's nothing in the /devfs directory in the initrd-img.

Now, it's entirely possible that this is all a stupid user trick: I got udev running by adding it into my system, but I didn't do anything else, such as a "rm -r" on my /dev directory. I have the compatibility rules package for udev running, so I see "vc/*" and the tty packages when I boot using devfs=mount.

If anyone has any hints or tricks that might fix this problem, or needs further data, please let me know.

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (990, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.12-1-k7
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)

Versions of packages initrd-tools depends on:
ii  coreutils [fileutils]         5.93-5     The GNU core utilities
ii  cpio                          2.6-9      GNU cpio -- a program to manage ar
ii  cramfsprogs                   1.1-6      Tools for CramFs (Compressed ROM F
ii  dash                          0.5.2-8    The Debian Almquist Shell
ii  fileutils                     5.93-5     The GNU file management utilities 
ii  util-linux                    2.12p-8    Miscellaneous system utilities

initrd-tools recommends no packages.

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#341152; Package initrd-tools. Full text and rfc822 format available.

Acknowledgement sent to Maximilian Attems <maks@sternwelten.at>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 341152@bugs.debian.org (full text, mbox):

From: Maximilian Attems <maks@sternwelten.at>
To: Moshe Yudkowsky <speech@pobox.com>, 341152@bugs.debian.org
Subject: Re: Bug#341152: initrd-tools: unable to boot after replacing devfs with udev: kernel panic, unable to create null, no console
Date: Mon, 28 Nov 2005 21:01:54 +0100
On Mon, Nov 28, 2005 at 12:59:34PM -0600, Moshe Yudkowsky wrote:
> I cannot get 2.6.12 or 2.6.12 to boot because of the transition from
> devfs to udev, and the problem seems to lie with initrd.
> 

initrd-tools is phasing out, if you use testing and udev 0.74
pick initramfs-tools 0.40 from unstable.
if you use newer udev you need initramfs-tools 0.41 from debian mentors
-> http://mentors.debian.net/debian/pool/main/i/initramfs-tools/

if that doesn't work out for you check the alternative yaird.

regards maks



Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#341152; Package initrd-tools. Full text and rfc822 format available.

Acknowledgement sent to Moshe Yudkowsky <speech@pobox.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 341152@bugs.debian.org (full text, mbox):

From: Moshe Yudkowsky <speech@pobox.com>
To: Maximilian Attems <maks@sternwelten.at>,341152@bugs.debian.org
Subject: Re: Bug#341152: initrd-tools: unable to boot after replacing devfs with udev: kernel panic, unable to create null, no console
Date: Mon, 28 Nov 2005 22:10:48 -0600
At 14:01 2005-11-28, Maximilian Attems wrote:
>On Mon, Nov 28, 2005 at 12:59:34PM -0600, Moshe Yudkowsky wrote:
> > I cannot get 2.6.12 or 2.6.12 to boot because of the transition from
> > devfs to udev, and the problem seems to lie with initrd.
> >
>
>initrd-tools is phasing out, if you use testing and udev 0.74
>pick initramfs-tools 0.40 from unstable.
>if you use newer udev you need initramfs-tools 0.41 from debian mentors
>-> http://mentors.debian.net/debian/pool/main/i/initramfs-tools/

Ok, the answer turns out to be quite simple: I didn't have the correct 
console and null files in my /dev directory.

IMO, this is a documentation problem, so let me document the fix. Here's 
how to transition from devfs to udev -- at least as far as booting.

Introduction: There's a difference between devfs and udev. Devfs makes the 
"console" and "null" files available by the time the files are needed 
during the boot. udev starts later, so you must supply your own copy of 
/dev/console and /dev/null.

Action: Therefore, before trying to boot using udev only, make certain you 
have a "console" and "null" file in /dev. Of course, if your system is 
running, you have these files now -- but the question is, were they part of 
the /dev directory, or did devfs put it there? Here's how to check.

* First, mount the root directory someplace other than /, so that the /dev 
directory can be examined as a standalone -- so it can be seen as it looks 
without stuff that devfs puts there. As root, issue the command:

# mount -o bind / /mnt

(where /mnt is some random mouting point).


* Next, look at /mnt/dev. You need to have two special files there, console 
and null:

crw------- root root 5, 1 Nov 28 16:50 console
crw-rw-rw- root root 1, 3 Nov 28 16:51 null

If you have them already, you're all set. On my system, I had "null" and it 
was *not* a "c" (special character) file; it was an ordinary file. I got 
rid of that file and issued the following commands to create console and null:

# mknod -m 660 console c 5 1
# mknod -m 660 null c 1 3

* Unmount the / file system:

# umount /mnt.

* Make certain you have udev! 2.6.14-2 requires udev to boot, but you are 
responsible for actually installing udev.
* Once /dev/console and /dev/null exist, you can boot using udev only. (For 
example, on my system, a boot using udev only is done by removing the 
"devfs=mount" command from lilo.) There's other stuff to do to convert 
completely to udev, but this gets you started.


-- 
 Moshe Yudkowsky
 Disaggregate
 2952 W Fargo
 Chicago, IL 60645 USA

 www.Disaggregate.com
 www.PebbleAndAvalanche.com
 speech@pobox.com
 +1 773 764 8727



Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#341152; Package initrd-tools. Full text and rfc822 format available.

Acknowledgement sent to Tomasz Chmielewski <mangoo@wpkg.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 341152@bugs.debian.org (full text, mbox):

From: Tomasz Chmielewski <mangoo@wpkg.org>
To: 341152@bugs.debian.org
Subject: Re: Bug#341152: initrd-tools: unable to boot after replacing, devfs with udev: kernel panic, unable to create null, no console
Date: Fri, 18 Apr 2008 18:21:57 +0200
Sounds like this bug could have been avoided if /dev/null and 
/dev/console were provided as static entries in udev package?



Tomasz Chmielewski
http://wpkg.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#341152; Package initrd-tools. Full text and rfc822 format available.

Acknowledgement sent to "Jeff Bailey" <jbailey@raspberryginger.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 341152@bugs.debian.org (full text, mbox):

From: "Jeff Bailey" <jbailey@raspberryginger.com>
To: "Tomasz Chmielewski" <mangoo@wpkg.org>, 341152@bugs.debian.org
Subject: Re: Bug#341152: initrd-tools: unable to boot after replacing, devfs with udev: kernel panic, unable to create null, no console
Date: Fri, 18 Apr 2008 10:06:15 -0700
Possibly, but the real answer is "don't do that.  initrd-tools doesn't
support udev.  That's what initramfs-tools is for."

Given that initrd-tools is only in stable, this bug won't ever get
fixed.  In another few months, Lenny will be released and then
initrd-tools will go away forever.

Tks,
Jeff Bailey

On Fri, Apr 18, 2008 at 9:21 AM, Tomasz Chmielewski <mangoo@wpkg.org> wrote:
> Sounds like this bug could have been avoided if /dev/null and /dev/console
> were provided as static entries in udev package?
>
>
>
>  Tomasz Chmielewski
>  http://wpkg.org
>
>
>
>



-- 
Jeff Bailey - http://www.raspberryginger.com/jbailey/
 - "Remember, homosexuality is a choice, like cancer" - midwestteensexshow.com




Reply sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Moshe Yudkowsky <speech@pobox.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #30 received at 341152-done@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: 341152-done@bugs.debian.org
Subject: initrd-tools has been removed from Debian, closing #341152
Date: Mon, 05 May 2008 10:23:25 +0200
Version: 0.1.84.2+rm

The initrd-tools package has been removed from Debian testing, unstable and
experimental, so I am now closing the bugs that were still opened
against it.

For more information about this package's removal, read
http://bugs.debian.org/393092 . That bug might give the reasons why
this package was removed, and suggestions of possible replacements.

Don't hesitate to reply to this mail if you have any question.

Thank you for your contribution to Debian.
-- 
Lucas




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 11 Aug 2008 08:01:02 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 19:50:16 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.